itests.sh 2.9 KB

123456789101112131415161718192021222324252627282930313233343536373839404142434445464748495051525354555657585960616263646566676869707172737475767778798081828384858687888990919293949596979899100101
  1. #!/usr/bin/env bash
  2. # Function to perform cleanup
  3. cleanup() {
  4. echo "Cleaning up..."
  5. # Kill the Rust binary process
  6. echo "Killing the Rust binary with PID $RUST_BIN_PID"
  7. kill $CDK_ITEST_MINT_BIN_PID
  8. # Wait for the Rust binary to terminate
  9. wait $CDK_ITEST_MINT_BIN_PID
  10. echo "Mint binary terminated"
  11. # Kill processes
  12. lncli --lnddir="$cdk_itests/lnd/one" --network=regtest stop
  13. lncli --lnddir="$cdk_itests/lnd/two" --network=regtest --rpcserver=localhost:10010 stop
  14. lightning-cli --regtest --lightning-dir="$cdk_itests/cln/one/" stop
  15. lightning-cli --regtest --lightning-dir="$cdk_itests/cln/two/" stop
  16. bitcoin-cli --datadir="$cdk_itests/bitcoin" -rpcuser=testuser -rpcpassword=testpass -rpcport=18443 stop
  17. # Remove the temporary directory
  18. rm -rf "$cdk_itests"
  19. echo "Temp directory removed: $cdk_itests"
  20. unset cdk_itests
  21. unset cdk_itests_mint_addr
  22. unset cdk_itests_mint_port
  23. }
  24. # Set up trap to call cleanup on script exit
  25. trap cleanup EXIT
  26. # Create a temporary directory
  27. export cdk_itests=$(mktemp -d)
  28. export cdk_itests_mint_addr="127.0.0.1";
  29. export cdk_itests_mint_port=8085;
  30. URL="http://$cdk_itests_mint_addr:$cdk_itests_mint_port/v1/info"
  31. # Check if the temporary directory was created successfully
  32. if [[ ! -d "$cdk_itests" ]]; then
  33. echo "Failed to create temp directory"
  34. exit 1
  35. fi
  36. echo "Temp directory created: $cdk_itests"
  37. export MINT_DATABASE="$1";
  38. cargo build -p cdk-integration-tests
  39. cargo build --bin regtest_mint
  40. # cargo run --bin regtest_mint > "$cdk_itests/mint.log" 2>&1 &
  41. cargo run --bin regtest_mint &
  42. echo $cdk_itests
  43. # Capture its PID
  44. CDK_ITEST_MINT_BIN_PID=$!
  45. TIMEOUT=100
  46. START_TIME=$(date +%s)
  47. # Loop until the endpoint returns a 200 OK status or timeout is reached
  48. while true; do
  49. # Get the current time
  50. CURRENT_TIME=$(date +%s)
  51. # Calculate the elapsed time
  52. ELAPSED_TIME=$((CURRENT_TIME - START_TIME))
  53. # Check if the elapsed time exceeds the timeout
  54. if [ $ELAPSED_TIME -ge $TIMEOUT ]; then
  55. echo "Timeout of $TIMEOUT seconds reached. Exiting..."
  56. exit 1
  57. fi
  58. # Make a request to the endpoint and capture the HTTP status code
  59. HTTP_STATUS=$(curl -o /dev/null -s -w "%{http_code}" $URL)
  60. # Check if the HTTP status is 200 OK
  61. if [ "$HTTP_STATUS" -eq 200 ]; then
  62. echo "Received 200 OK from $URL"
  63. break
  64. else
  65. echo "Waiting for 200 OK response, current status: $HTTP_STATUS"
  66. sleep 2 # Wait for 2 seconds before retrying
  67. fi
  68. done
  69. # Run cargo test
  70. cargo test -p cdk-integration-tests --test regtest
  71. # # Run cargo test with the http_subscription feature
  72. cargo test -p cdk-integration-tests --test regtest --features http_subscription
  73. # Run tests with lnd mint
  74. export cdk_itests_mint_port=8087;
  75. cargo test -p cdk-integration-tests --test regtest
  76. # Capture the exit status of cargo test
  77. test_status=$?
  78. # Exit with the status of the tests
  79. exit $test_status